import { Grid} from "@mui/material";
import React, { memo, useEffect, useState} from "react";



const CalendarTask = ({setCurrentTask, handleOpen, task, line, setCurrentLine, currentLine, currentTask,  dragTaskHandler, hour}) => {

  const [color, setColor] = useState('')
  useEffect(() => {
    if (task.priority) {
      if (task.priority === 'A') setColor('rgb(32, 138, 250)')
      if (task.priority === 'B') setColor('lightgreen')
      if (task.priority === 'C') setColor('yellow')
    } else {
      setColor('rgb(171, 157, 157);')
    }
  }, [task])


  const onClickTaskHandler = (e, task) => {
    e.stopPropagation(); 
    setCurrentTask(task); 
    handleOpen(e)
  }

  const dragOverHandler = (e) => {
    e.preventDefault();
    e.target.style.boxShadow = '0 4px 3px grey'
  }
  const dragLeaveHandler = (e) => {
    e.target.style.boxShadow = 'none'
  }
  const dragStartHandler = (e, line, task) => {
    setCurrentLine()
    setCurrentTask(task); 
  }
  const dragEndHandler = (e) => {
    e.target.style.boxShadow = 'none'
  }
  const dropHandler = (e, line, task) => {
    e.stopPropagation()
    e.preventDefault();
    console.log(hour)
    dragTaskHandler(line, hour)
  }
  
  return (<>
    <Grid  
        draggable={true} 
        onDragOver={(e)=>{dragOverHandler(e)}}
        onDragLeave={(e)=>{dragLeaveHandler(e)}}
        onDragStart={(e)=>{dragStartHandler(e, line, task)}}
        onDragEnd={(e)=>{dragEndHandler(e)}}
        onDrop={(e)=>{dropHandler(e, line, task)}}
        sx={{ position: 'relative', height: '30px', backgroundColor: color, whiteSpace: 'nowrap', overflow: 'hidden', textOverflow: 'ellipsis', borderRadius: '10px', margin: '5px 10px', display: 'flex', justifyContent: 'flex-start', alignItems: 'center', paddingLeft: '5px', zIndex: '5'}} 
        onClick={(e)=>{onClickTaskHandler(e, task)}}
      >
      <span>
        {task.title}
      </span>
    </Grid>
  </>)
};

export default memo(CalendarTask);